package rocks.zipcode.quiz5.collections.bank;

import org.junit.Assert;
import org.junit.Test;
import rocks.zipcode.quiz5.collections.Bank;
import rocks.zipcode.quiz5.objectorientation.account.BankAccount;

public class RemoveBankAccountByIndexTest {
    @Test
    public void test1() {
        // given
        Bank bank = new Bank();
        BankAccount bankAccount = new BankAccount();
        bank.addBankAccount(bankAccount);
        Assert.assertTrue(bank.containsBankAccount(bankAccount));

        // when
        bank.removeBankAccountByIndex(0);

        // then
        Assert.assertFalse(bank.containsBankAccount(bankAccount));
    }

    @Test
    public void test2() {
        // given
        Bank bank = new Bank();
        BankAccount bankAccount1 = new BankAccount();
        BankAccount bankAccount2 = new BankAccount();

        bank.addBankAccount(bankAccount1);
        bank.addBankAccount(bankAccount2);

        Assert.assertTrue(bank.containsBankAccount(bankAccount1));
        Assert.assertTrue(bank.containsBankAccount(bankAccount2));

        // when
        bank.removeBankAccountByIndex(1);

        // then
        Assert.assertTrue(bank.containsBankAccount(bankAccount1));
        Assert.assertFalse(bank.containsBankAccount(bankAccount2));
    }
}
