package rocks.zipcode.quiz5.objectorientation.food;

import org.junit.Assert;
import org.junit.Test;
import rocks.zipcode.quiz5.collections.Food;
import rocks.zipcode.quiz5.objectorientation.Curry;
import rocks.zipcode.quiz5.objectorientation.Ginger;
import rocks.zipcode.quiz5.objectorientation.Pepper;
import rocks.zipcode.quiz5.objectorientation.Spice;

import java.util.Map;
import java.util.function.Supplier;

public class GetSpiceCountTest {
    @Test
    public void test1() {
        test(5, Pepper::new);
    }

    @Test
    public void test2() {
        test(10, Pepper::new);
    }

    @Test
    public void test3() {
        test(3, Curry::new);
    }


    @Test
    public void test4() {
        test(6, Curry::new);
    }

    @Test
    public void test5() {
        test(2, Ginger::new);
    }

    @Test
    public void test6() {
        test(4, Ginger::new);
    }

    public void test(Integer amountOfIngredients, Supplier<?> ingredientConstructor) {
        // given
        Integer expected = amountOfIngredients;
        Food food = new Food();
        Spice pepper = null;
        for (int i = 0; i < amountOfIngredients; i++) {
            pepper = (Spice) ingredientConstructor.get();
            food.applySpice(pepper);
        }

        // when
        Map<Class<? extends Spice>, Integer> amountOfPeppers = food.getSpiceCount();
        Integer actual = amountOfPeppers.get(pepper.getClass());

        // then
        Assert.assertEquals(expected, actual);
    }
}
